/* http://arduino.cc/en/Hacking/LibraryTutorial */
/* http://ww1.microchip.com/downloads/en/DeviceDoc/22250A.pdf */
int counter = 0; 
 int aState;
 int aLastState; 


  #define outputA 2
 #define outputB 3
#include <MCP4922.h>
#include <SPI.h>
//MCP4922 DAC(51,52,53,5);    // (MOSI,SCK,CS,LDAC) define Connections for MEGA_board, 
MCP4922 DAC(11,13,10,5);    // (MOSI,SCK,CS,LDAC) define Connections for UNO_board, 

void setup()
{

  pinMode (outputA,INPUT_PULLUP);
   pinMode (outputB,INPUT_PULLUP);
   
   Serial.begin (9600);
   // Reads the initial state of the outputA
   aLastState = digitalRead(outputA);  
   
  Serial.begin(9600);
  SPI.begin();
Serial.println("_" + String(counter) + "_" + String(analogRead(0)) + "_");
}

void loop()
{


if(Serial.available() > 0){
  counter = Serial.parseInt(); //read int or parseFloat for ..float...
delay(50);
DAC.Set(counter,counter);
delay(100);
Serial.println("_" + String(counter) + "_" + String(analogRead(0)) + "_");
  }



   aState = digitalRead(outputA);

   if (aState != aLastState){     
     // If the outputB state is different to the outputA state, that means the encoder is rotating clockwise
     if (digitalRead(outputB) != aState) { 
       counter ++;
     } else {
       counter --;
     }
     Serial.print("Position: ");
     Serial.println(counter);
     DAC.Set(counter,counter);
   } 
   aLastState = aState;
   
 // for(int i = 0 ; i < 32 ; i++)
 // {
 //  DAC.Set((sinetable[i]*3)+400,i); delay(1000);
  // Serial.print (analogRead(A2)); Serial.print("  "); Serial.println (analogRead(A3));
 // }
}

